import { ElementRef } from '@angular/core';
import { IFallimgSource } from './ng-fallimg-sources';
/**
 * Directive for handling the default image when the main image doesn't works
 */
export declare class NgFallimgDirective {
    private el;
    private fallimgSources;
    /**
     * Input that receive an optional key for returning the source
     */
    fallimg: string;
    /**
     * It contains the last source setted when the main source fails
     */
    private lastSource;
    /**
     *
     * @param el ElementRef service
     * @param fallimgSources Injector token that contains all the fallback sources
     */
    constructor(el: ElementRef, fallimgSources: IFallimgSource);
    /**
     * It handles the error when the main image doesn't load
     */
    private errorImgHandler;
}
